package com.hfkj.dao;

import com.hfkj.entity.BsBankActivity;
import com.hfkj.entity.BsBankActivityExample.Criteria;
import com.hfkj.entity.BsBankActivityExample.Criterion;
import com.hfkj.entity.BsBankActivityExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsBankActivitySqlProvider {

    public String countByExample(BsBankActivityExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_bank_activity");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsBankActivityExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_bank_activity");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsBankActivity record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_bank_activity");
        
        if (record.getRegions() != null) {
            sql.VALUES("regions", "#{regions,jdbcType=VARCHAR}");
        }
        
        if (record.getActivityNo() != null) {
            sql.VALUES("activity_no", "#{activityNo,jdbcType=BIGINT}");
        }
        
        if (record.getActivityName() != null) {
            sql.VALUES("activity_name", "#{activityName,jdbcType=VARCHAR}");
        }
        
        if (record.getPosScope() != null) {
            sql.VALUES("pos_scope", "#{posScope,jdbcType=VARCHAR}");
        }
        
        if (record.getEffectiveStart() != null) {
            sql.VALUES("effective_start", "#{effectiveStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEffectiveEnd() != null) {
            sql.VALUES("effective_end", "#{effectiveEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationStart() != null) {
            sql.VALUES("registration_start", "#{registrationStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationEnd() != null) {
            sql.VALUES("registration_end", "#{registrationEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDetails() != null) {
            sql.VALUES("details", "#{details,jdbcType=VARCHAR}");
        }
        
        if (record.getComments() != null) {
            sql.VALUES("comments", "#{comments,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsBankActivityExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("regions");
        sql.SELECT("activity_no");
        sql.SELECT("activity_name");
        sql.SELECT("pos_scope");
        sql.SELECT("effective_start");
        sql.SELECT("effective_end");
        sql.SELECT("registration_start");
        sql.SELECT("registration_end");
        sql.SELECT("details");
        sql.SELECT("comments");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_bank_activity");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsBankActivity record = (BsBankActivity) parameter.get("record");
        BsBankActivityExample example = (BsBankActivityExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getRegions() != null) {
            sql.SET("regions = #{record.regions,jdbcType=VARCHAR}");
        }
        
        if (record.getActivityNo() != null) {
            sql.SET("activity_no = #{record.activityNo,jdbcType=BIGINT}");
        }
        
        if (record.getActivityName() != null) {
            sql.SET("activity_name = #{record.activityName,jdbcType=VARCHAR}");
        }
        
        if (record.getPosScope() != null) {
            sql.SET("pos_scope = #{record.posScope,jdbcType=VARCHAR}");
        }
        
        if (record.getEffectiveStart() != null) {
            sql.SET("effective_start = #{record.effectiveStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEffectiveEnd() != null) {
            sql.SET("effective_end = #{record.effectiveEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationStart() != null) {
            sql.SET("registration_start = #{record.registrationStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationEnd() != null) {
            sql.SET("registration_end = #{record.registrationEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDetails() != null) {
            sql.SET("details = #{record.details,jdbcType=VARCHAR}");
        }
        
        if (record.getComments() != null) {
            sql.SET("comments = #{record.comments,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("regions = #{record.regions,jdbcType=VARCHAR}");
        sql.SET("activity_no = #{record.activityNo,jdbcType=BIGINT}");
        sql.SET("activity_name = #{record.activityName,jdbcType=VARCHAR}");
        sql.SET("pos_scope = #{record.posScope,jdbcType=VARCHAR}");
        sql.SET("effective_start = #{record.effectiveStart,jdbcType=TIMESTAMP}");
        sql.SET("effective_end = #{record.effectiveEnd,jdbcType=TIMESTAMP}");
        sql.SET("registration_start = #{record.registrationStart,jdbcType=TIMESTAMP}");
        sql.SET("registration_end = #{record.registrationEnd,jdbcType=TIMESTAMP}");
        sql.SET("details = #{record.details,jdbcType=VARCHAR}");
        sql.SET("comments = #{record.comments,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsBankActivityExample example = (BsBankActivityExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsBankActivity record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity");
        
        if (record.getRegions() != null) {
            sql.SET("regions = #{regions,jdbcType=VARCHAR}");
        }
        
        if (record.getActivityNo() != null) {
            sql.SET("activity_no = #{activityNo,jdbcType=BIGINT}");
        }
        
        if (record.getActivityName() != null) {
            sql.SET("activity_name = #{activityName,jdbcType=VARCHAR}");
        }
        
        if (record.getPosScope() != null) {
            sql.SET("pos_scope = #{posScope,jdbcType=VARCHAR}");
        }
        
        if (record.getEffectiveStart() != null) {
            sql.SET("effective_start = #{effectiveStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEffectiveEnd() != null) {
            sql.SET("effective_end = #{effectiveEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationStart() != null) {
            sql.SET("registration_start = #{registrationStart,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRegistrationEnd() != null) {
            sql.SET("registration_end = #{registrationEnd,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDetails() != null) {
            sql.SET("details = #{details,jdbcType=VARCHAR}");
        }
        
        if (record.getComments() != null) {
            sql.SET("comments = #{comments,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsBankActivityExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}